import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:bee_miraculous' && player.isSneaking == true ) system.run(() => beeMiraculousPreferenceMenu(player));

	function beeMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.miraculous.preference');
			form.button('button.suit.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					beeMiraculousPreference(player);
				}
				if(r.selection == 1) {
					beeMiraculousSuitPreference(player);
				}
			}
		)
	}
	function beeMiraculousPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Alya', 'textures/items/miraculous/bee_miraculous/camouflages/camo_bee_miraculous');
			form.button('Marinette', 'textures/items/miraculous/bee_miraculous/camouflages/marinette_camo_bee_miraculous');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag("marinette_bee");
					player.addTag("chloe_bee");
				}
				if(r.selection == 1) {
					player.removeTag("chloe_bee");
					player.addTag("marinette_bee");
				}
			}
		)
	}
	function beeMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Queen Bee');
			form.button('Vesperia');
			form.button('Marigold');
			form.button('Honey Comb');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('honey_comb');
					player.removeTag('vesperia');
					player.removeTag('marigold');
					player.addTag('queen_bee');
				}
				if(r.selection == 1) {
					player.removeTag('honey_comb');
					player.removeTag('queen_bee');
					player.removeTag('marigold');
					player.addTag('vesperia');
				}
				if(r.selection == 2) {
					player.removeTag('honey_comb');
					player.removeTag('queen_bee');
					player.removeTag('vesperia');
					player.addTag('marigold');
				}
				if(r.selection == 3) {
					player.removeTag('marigold');
					player.removeTag('queen_bee');
					player.removeTag('vesperia');
					player.addTag('honey_comb');
				}
			}
		)
	}
});