import { world } from '@minecraft/server';

const blackCatItems = [
'miraculous:camo_black_cat_miraculous',
'miraculous:marinette_camo_black_cat_miraculous',
'miraculous:zoe_camo_black_cat_miraculous'
];
const blackCatMiraculousCharged = [
'miraculous:black_cat_miraculous_charged',
'miraculous:maotif_miraculous_charged'
];

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (blackCatItems.includes(itemType)) {
			event.source.runCommandAsync('tp @e[type=miraculous:plagg, c=1] @s');
		}
		if (blackCatMiraculousCharged.includes(itemType)) {
			event.source.runCommandAsync('event entity @s is_black_cat_detransformation');
		}
		if (!event.source.isSneaking) {
			if (itemType == 'miraculous:black_cat_miraculous') {
				event.source.runCommandAsync('gamerule sendcommandfeedback false');
				event.source.runCommandAsync('tag @s[tag=!zoe_black_cat, tag=!marinette_black_cat] add adrien_black_cat');
				event.source.runCommandAsync('tag @s[tag=!lady_noire, tag=!cat_walker, tag=!maotif, tag=!claw_noir, tag=!kitty_noir] add cat_noir');
				event.source.runCommandAsync('replaceitem entity @s[tag=adrien_black_cat] slot.weapon.mainhand 0 miraculous:camo_black_cat_miraculous 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('replaceitem entity @s[tag=marinette_black_cat] slot.weapon.mainhand 0 miraculous:marinette_camo_black_cat_miraculous 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('replaceitem entity @s[tag=zoe_black_cat] slot.weapon.mainhand 0 miraculous:zoe_camo_black_cat_miraculous 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('summon miraculous:plagg ~~~~~ miraculous:kwami_hungry');
				event.source.runCommandAsync('playsound mini_box @a ~~~');
			}
		}
	}
);
world.beforeEvents.itemUseOn.subscribe((event) => {
	if (event.itemStack.typeId === "miraculous:cataclysm_item") {
		event.source.runCommandAsync("execute as @s run playsound cataclysm @s ~5~5~5");

		const x = event.block.location.x;
		const y = event.block.location.y;
		const z = event.block.location.z;

		event.source.runCommandAsync(`execute positioned ${x} ${y} ${z} run fill ~~~~~~ miraculous:cataclysm_block`);
	}
});
world.beforeEvents.worldInitialize.subscribe(initEvent => {
	initEvent.itemComponentRegistry.registerCustomComponent('miraculous:cataclysm_hit', {
	onHitEntity: (e) => {
		(e.itemStack, e.source, true);
			e.attackingEntity.runCommand("clear @s miraculous:cataclysm_item 0 1");
				const targetEntity = e.hitEntity;
					if (targetEntity) {
						targetEntity.runCommand("effect @s wither 100 1");
					}
				},
			}
		);
	}
);