import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:black_cat_miraculous' && player.isSneaking == true ) system.run(() => blackCatMiraculousPreferenceMenu(player));

	function blackCatMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.miraculous.preference');
			form.button('button.suit.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					blackCatMiraculousPreference(player);
				}
				if(r.selection == 1) {
					blackCatMiraculousSuitPreference(player);
				}
			}
		)
	}
	function blackCatMiraculousPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Adrien', 'textures/items/miraculous/black_cat_miraculous/camouflages/camo_black_cat_miraculous');
			form.button('Marinette', 'textures/items/miraculous/black_cat_miraculous/camouflages/marinette_camo_black_cat_miraculous');
			form.button('Zoé', 'textures/items/miraculous/black_cat_miraculous/camouflages/zoe_camo_black_cat_miraculous');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag("zoe_black_cat");
					player.removeTag("marinette_black_cat");
					player.addTag("adrien_black_cat");
				}
				if(r.selection == 1) {
					player.removeTag("adrien_black_cat");
					player.removeTag("zoe_black_cat");
					player.addTag("marinette_black_cat");
				}
				if(r.selection == 2) {
					player.removeTag("adrien_black_cat");
					player.removeTag("marinette_black_cat");
					player.addTag("zoe_black_cat");
				}
			}
		)
	}
	function blackCatMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Cat Noir');
			form.button('Lady Noire');
			form.button('Cat Walker');
			form.button('Maotif');
			form.button('Claw Noir');
			form.button('Kitty Noir');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('kitty_noir');
					player.removeTag('claw_noir');
					player.removeTag('lady_noire');
					player.removeTag('cat_walker');
					player.removeTag('maotif');
					player.addTag('cat_noir');
				}
				if(r.selection == 1) {
					player.removeTag('kitty_noir');
					player.removeTag('claw_noir');
					player.removeTag('cat_noir');
					player.removeTag('cat_walker');
					player.removeTag('maotif');
					player.addTag('lady_noire');
				}
				if(r.selection == 2) {
					player.removeTag('kitty_noir');
					player.removeTag('claw_noir');
					player.removeTag('lady_noire');
					player.removeTag('cat_noir');
					player.removeTag('maotif');
					player.addTag('cat_walker');
				}
				if(r.selection == 3) {
					player.removeTag('kitty_noir');
					player.removeTag('claw_noir');
					player.removeTag('lady_noire');
					player.removeTag('cat_walker');
					player.removeTag('cat_noir');
					player.addTag('maotif');
				}
				if(r.selection == 4) {
					player.removeTag('kitty_noir');
					player.removeTag('cat_noir');
					player.removeTag('lady_noire');
					player.removeTag('cat_walker');
					player.removeTag('maotif');
					player.addTag('claw_noir');
				}
				if(r.selection == 5) {
					player.removeTag('cat_noir');
					player.removeTag('claw_noir');
					player.removeTag('lady_noire');
					player.removeTag('cat_walker');
					player.removeTag('maotif');
					player.addTag('kitty_noir');
				}
			}
		)
	}
});