import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

const blackCatStaffItems = [
'miraculous:black_cat_staff',
'miraculous:maotif_staff'
];
const blackCatUmbrellaItems = [
'miraculous:black_cat_umbrella',
'miraculous:maotif_umbrella'
];

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (!event.source.isSneaking) {
			if (blackCatStaffItems.includes(itemType)) {
				event.source.runCommandAsync('effect @s levitation 1 20 true');
				event.source.runCommandAsync('playsound cat_staff @a ~~~');
			}
		}
		if (blackCatUmbrellaItems.includes(itemType)) {
				event.source.runCommandAsync('replaceitem entity @s[tag=!is_fusion, tag=!maotif] slot.weapon.mainhand 0 miraculous:black_cat_staff 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('replaceitem entity @s[tag=!is_fusion, tag=maotif] slot.weapon.mainhand 0 miraculous:maotif_staff 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('replaceitem entity @s[tag=is_fusion] slot.weapon.mainhand 0 miraculous:black_cat_staff 1 0 {\"keep_on_death\":{}}');
		}
	}
);
world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (blackCatStaffItems.includes(itemType) && !player.hasTag('use_cataclysm') && player.isSneaking == true) system.run(() => catMiraculousPowerMenu(player));

	function catMiraculousPowerMenu() {
		const form = new ActionFormData();
			form.title('title.cat_staff_menu');
			form.button('button.cataclysm');
			form.button('button.umbrella');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.runCommandAsync('tellraw @a[tag=!use_cataclysm, tag=!maotif] {\"rawtext\":[{\"text\":\"§a<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:cataclysm\"}]}');
					player.runCommandAsync('tellraw @a[tag=!use_cataclysm, tag=maotif] {\"rawtext\":[{\"text\":\"§b<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:cataclysm\"}]}');
					player.runCommandAsync('playsound cataclysm_activation @a ~~~');
					player.runCommandAsync('clear @s miraculous:cataclysm_item');
					player.runCommandAsync('give @s[tag=!use_cataclysm] miraculous:cataclysm_item');
					system.runTimeout(() => {
					player.runCommandAsync('clear @s miraculous:cataclysm_item');
					}, 100);
					player.runCommandAsync('tag @s[tag=!use_cataclysm, tag=!full_power] add use_cataclysm');
					player.runCommandAsync('tag @s[tag=use_cataclysm, tag=!full_power] add black_cat_miraculous_timer_on');
				}
				if(r.selection == 1) {
					player.runCommandAsync('replaceitem entity @s[tag=!is_fusion, tag=!maotif] slot.weapon.mainhand 0 miraculous:black_cat_umbrella 1 0 {\"keep_on_death\":{}}');
					player.runCommandAsync('replaceitem entity @s[tag=!is_fusion, tag=maotif] slot.weapon.mainhand 0 miraculous:maotif_umbrella 1 0 {\"keep_on_death\":{}}');
					player.runCommandAsync('replaceitem entity @s[tag=is_fusion] slot.weapon.mainhand 0 miraculous:black_cat_umbrella 1 0 {\"keep_on_death\":{}}');
				}
			}
		)
	}
});