import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

const butterflyCaneItems = [
'miraculous:butterfly_cane',
'miraculous:betterfly_cane',
'miraculous:ladyfly_cane'
];

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (!event.source.isSneaking) {
			if (butterflyCaneItems.includes(itemType)) {
				event.source.runCommandAsync('execute as @s[tag=is_captured_butterfly] run summon miraculous:butterfly');
				event.source.runCommandAsync('tag @s[tag=is_captured_butterfly] remove is_captured_butterfly');
			}
		}
	}
);
world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (butterflyCaneItems.includes(itemType) && !player.hasTag('use_transmission') && player.isSneaking == true) system.run(() => butterflyMiraculousPowerMenu(player));

	function butterflyMiraculousPowerMenu() {
		const form = new ActionFormData();
			form.title('title.choose_mob');
			form.button('button.mob');
			form.button('button.player');
			form.show(player).then(r => {
				if(r.selection == 0) {
					MobMenu(player);
				}
				if(r.selection == 1) {
					PlayerMenu(player);
				}
			}
		)
	}
	function MobMenu() {
		const form = new ActionFormData();
			form.title('title.choose_mob');
			form.button('button.zombie');
			form.button('button.creeper');
			form.button('button.skeleton');
			form.button('button.spider');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('player_chosen');
					player.removeTag('spider_chosen');
					player.removeTag('skeleton_chosen');
					player.removeTag('creeper_chosen');
					player.addTag('zombie_chosen');
					player.addTag("butterfly_chosen");
				}
				if(r.selection == 1) {
					player.removeTag('player_chosen');
					player.removeTag('zombie_chosen');
					player.removeTag('spider_chosen');
					player.removeTag('skeleton_chosen');
					player.addTag('creeper_chosen');
					player.addTag("butterfly_chosen");
				}
				if(r.selection == 2) {
					player.removeTag('player_chosen');
					player.removeTag('zombie_chosen');
					player.removeTag('spider_chosen');
					player.removeTag('creeper_chosen');
					player.addTag('skeleton_chosen');
					player.addTag("butterfly_chosen");
				}
				if(r.selection == 3) {
					player.removeTag('player_chosen');
					player.removeTag('zombie_chosen');
					player.removeTag('skeleton_chosen');
					player.removeTag('creeper_chosen');
					player.addTag('spider_chosen');
					player.addTag("butterfly_chosen");
				}
			}
		)
	}
	function PlayerMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.bubbler');
			form.button('button.mr_pigeon');
			form.button('button.lady_wifi');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('zombie_chosen');
					player.removeTag('spider_chosen');
					player.removeTag('skeleton_chosen');
					player.removeTag('creeper_chosen');
					player.runCommandAsync('tag @e[tag=mr_pigeon] remove mr_pigeon');
					player.runCommandAsync('tag @e[tag=lady_wifi] remove lady_wifi');
					player.runCommandAsync('tag @e add bubbler');
					player.addTag("butterfly_chosen");
					player.addTag("player_chosen");
				}
				if(r.selection == 1) {
					player.removeTag('zombie_chosen');
					player.removeTag('spider_chosen');
					player.removeTag('skeleton_chosen');
					player.removeTag('creeper_chosen');
					player.runCommandAsync('tag @e[tag=bubbler] remove bubbler');
					player.runCommandAsync('tag @e[tag=lady_wifi] remove lady_wifi');
					player.runCommandAsync('tag @e add mr_pigeon');
					player.addTag("butterfly_chosen");
					player.addTag("player_chosen");
				}
				if(r.selection == 2) {
					player.removeTag('zombie_chosen');
					player.removeTag('spider_chosen');
					player.removeTag('skeleton_chosen');
					player.removeTag('creeper_chosen');
					player.runCommandAsync('tag @e[tag=bubbler] remove bubbler');
					player.runCommandAsync('tag @e[tag=mr_pigeon] remove mr_pigeon');
					player.runCommandAsync('tag @e add lady_wifi');
					player.addTag("butterfly_chosen");
					player.addTag("player_chosen");
				}
			}
		)
	}
});