import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:butterfly_miraculous' && player.isSneaking == true ) system.run(() => butterflyMiraculousPreferenceMenu(player));

	function butterflyMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.suit.preference');
			form.button('button.fusion.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					butterflyMiraculousSuitPreference(player);
				}
				if(r.selection == 1) {
					butterflyMiraculousFusionPreference(player);
				}
			}
		)
	}
	function butterflyMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Hawk Moth');
			form.button('Monarch 1');
			form.button('Monarch 2');
			form.button('Betterfly');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('monarch1');
					player.removeTag('monarch2');
					player.removeTag('betterfly');
					player.addTag('hawk_moth');
				}
				if(r.selection == 1) {
					player.removeTag('hawk_moth');
					player.removeTag('monarch2');
					player.removeTag('betterfly');
					player.addTag('monarch1');
				}
				if(r.selection == 2) {
					player.removeTag('betterfly');
					player.removeTag('hawk_moth');
					player.removeTag('monarch1');
					player.addTag('monarch2');
				}
				if(r.selection == 3) {
					player.removeTag('hawk_moth');
					player.removeTag('monarch2');
					player.removeTag('monarch1');
					player.addTag('betterfly');
				}
			}
		)
	}
	function butterflyMiraculousFusionPreference() {
		const form = new ActionFormData();
			form.title('title.choose_suit');
			form.button('Monarch Bug');
			form.button('Ladyfly');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('ladyfly');
					player.addTag('monarch_bug');
				}
				if(r.selection == 1) {
					player.removeTag('monarch_bug');
					player.addTag('ladyfly');
				}
			}
		)
	}
});