import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:fox_miraculous' && player.isSneaking == true ) system.run(() => foxMiraculousPreferenceMenu(player));

	function foxMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.miraculous.preference');
			form.button('button.suit.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					foxMiraculousPreference(player);
				}
				if(r.selection == 1) {
					foxMiraculousSuitPreference(player);
				}
			}
		)
	}
	function foxMiraculousPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Alya', 'textures/items/miraculous/fox_miraculous/camouflages/camo_fox_miraculous');
			form.button('Marinette', 'textures/items/miraculous/fox_miraculous/camouflages/marinette_camo_fox_miraculous');
			form.button('Gabriel', 'textures/items/miraculous/fox_miraculous/camouflages/gabriel_camo_fox_miraculous');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag("gabriel_fox");
					player.removeTag("marinette_fox");
					player.addTag("alya_fox");
				}
				if(r.selection == 1) {
					player.removeTag("alya_fox");
					player.removeTag("gabriel_fox");
					player.addTag("marinette_fox");
				}
				if(r.selection == 2) {
					player.removeTag("alya_fox");
					player.removeTag("marinette_fox");
					player.addTag("gabriel_fox");
				}
			}
		)
	}
	function foxMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Rena Rouge');
			form.button('Rena Furtive');
			form.button('Fox Trot');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('fox_trot');
					player.removeTag('rena_furtive');
					player.addTag('rena_rouge');
				}
				if(r.selection == 1) {
					player.removeTag('fox_trot');
					player.removeTag('rena_rouge');
					player.addTag('rena_furtive');
				}
				if(r.selection == 2) {
					player.removeTag('rena_furtive');
					player.removeTag('rena_rouge');
					player.addTag('fox_trot');
				}
			}
		)
	}
});