import { world } from '@minecraft/server';

const ladybugItems = [
'miraculous:camo_ladybug_miraculous',
'miraculous:alya_camo_ladybug_miraculous',
'miraculous:adrien_camo_ladybug_miraculous'
];
const ladybugMiraculousCharged = [
'miraculous:ladybug_miraculous_charged',
'miraculous:chronobug_miraculous_charged'
];

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (ladybugItems.includes(itemType)) {
			event.source.runCommandAsync('tp @e[type=miraculous:tikki, c=1] @s');
		}
		if (ladybugMiraculousCharged.includes(itemType)) {
			event.source.runCommandAsync('event entity @s is_ladybug_detransformation');
		}
		if (!event.source.isSneaking) {
			if (itemType == 'miraculous:ladybug_miraculous') {
				event.source.runCommandAsync('gamerule sendcommandfeedback false');
				event.source.runCommandAsync('tag @s[tag=!alya_ladybug, tag=!adrien_ladybug] add marinette_ladybug');
				event.source.runCommandAsync('tag @s[tag=!mister_bug, tag=!scarabella, tag=!scarlet_lady, tag=!shadybug, tag=!chronobug] add ladybug');
				event.source.runCommandAsync('tag @s[tag=ladybug] add is_lucky_charm');
				event.source.runCommandAsync('replaceitem entity @s[tag=marinette_ladybug] slot.weapon.mainhand 0 miraculous:camo_ladybug_miraculous 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('replaceitem entity @s[tag=alya_ladybug] slot.weapon.mainhand 0 miraculous:alya_camo_ladybug_miraculous 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('replaceitem entity @s[tag=adrien_ladybug] slot.weapon.mainhand 0 miraculous:adrien_camo_ladybug_miraculous 1 0 {\"keep_on_death\":{}}');
				event.source.runCommandAsync('summon miraculous:tikki ~~~~~ miraculous:kwami_hungry');
				event.source.runCommandAsync('playsound mini_box @a ~~~');
			}
		}
	}
);
world.beforeEvents.itemUseOn.subscribe((event) => {
	if (event.itemStack.typeId === "miraculous:lucky_charm_flint_and_steel") {
		event.source.runCommandAsync("execute as @s run playsound fire.ignite @s ~5 ~5 ~5");

		const x = event.block.location.x;
		const y = event.block.location.y;
		const z = event.block.location.z;

		switch(event.blockFace) {
			case "Up":
			event.source.runCommandAsync(`execute positioned ${x} ${y} ${z} run fill ~ ~1 ~ ~ ~ ~ fire replace air`);
				break;
			case "Down":
			event.source.runCommandAsync(`execute positioned ${x} ${y - 2} ${z} run fill ~ ~1 ~ ~ ~ ~ fire replace air`);
				break;
			case "North":
			event.source.runCommandAsync(`execute positioned ${x} ${y} ${z} run fill ~ ~ ~-1 ~ ~ ~-1 fire replace air`);
				break;
			case "South":
			event.source.runCommandAsync(`execute positioned ${x} ${y} ${z} run fill ~ ~ ~1 ~ ~ ~1 fire replace air`);
				break;
			case "East":
			event.source.runCommandAsync(`execute positioned ${x} ${y} ${z} run fill ~1 ~ ~ ~1 ~ ~ fire replace air`);
				break;
			case "West":
			event.source.runCommandAsync(`execute positioned ${x} ${y} ${z} run fill ~-1 ~ ~ ~-1 ~ ~ fire replace air`);
				break;
			default:
				break;
			}
		}
	}
);