import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:ladybug_miraculous' && player.isSneaking == true ) system.run(() => ladybugMiraculousPreferenceMenu(player));

	function ladybugMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.miraculous.preference');
			form.button('button.suit.preference');
			form.button('button.fusion.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					ladybugMiraculousPreference(player);
				}
				if(r.selection == 1) {
					ladybugMiraculousSuitPreference(player);
				}
				if(r.selection == 2) {
					ladybugMiraculousFusionPreference(player);
				}
			}
		)
	}
	function ladybugMiraculousPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Marinette', 'textures/items/miraculous/ladybug_miraculous/camouflages/camo_ladybug_miraculous');
			form.button('Alya', 'textures/items/miraculous/ladybug_miraculous/camouflages/alya_camo_ladybug_miraculous');
			form.button('Adrien', 'textures/items/miraculous/ladybug_miraculous/camouflages/adrien_camo_ladybug_miraculous');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag("adrien_ladybug");
					player.removeTag("alya_ladybug");
					player.addTag("marinette_ladybug");
				}
				if(r.selection == 1) {
					player.removeTag("adrien_ladybug");
					player.removeTag("marinette_ladybug");
					player.addTag("alya_ladybug");
				}
				if(r.selection == 2) {
					player.removeTag("marinette_ladybug");
					player.removeTag("alya_ladybug");
					player.addTag("adrien_ladybug");
				}
			}
		)
	}
	function ladybugMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Ladybug');
			form.button('Mister Bug');
			form.button('Scarabella');
			form.button('Scarlet Lady');
			form.button('Shadybug');
			form.button('Chronobug');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('mister_bug');
					player.removeTag('scarabella');
					player.removeTag('scarlet_lady');
					player.removeTag('shadybug');
					player.removeTag('chronobug');
					player.addTag('is_lucky_charm');
					player.addTag('ladybug');
				}
				if(r.selection == 1) {
					player.removeTag('is_lucky_charm');
					player.removeTag('ladybug');
					player.removeTag('scarabella');
					player.removeTag('scarlet_lady');
					player.removeTag('shadybug');
					player.removeTag('chronobug');
					player.addTag('mister_bug');
				}
				if(r.selection == 2) {
					player.removeTag('is_lucky_charm');
					player.removeTag('ladybug');
					player.removeTag('mister_bug');
					player.removeTag('shadybug');
					player.removeTag('scarlet_lady');
					player.removeTag('chronobug');
					player.addTag('scarabella');
				}
				if(r.selection == 3) {
					player.removeTag('is_lucky_charm');
					player.removeTag('ladybug');
					player.removeTag('mister_bug');
					player.removeTag('scarabella');
					player.removeTag('shadybug');
					player.removeTag('chronobug');
					player.addTag('scarlet_lady');
				}
				if(r.selection == 4) {
					player.removeTag('is_lucky_charm');
					player.removeTag('ladybug');
					player.removeTag('mister_bug');
					player.removeTag('scarabella');
					player.removeTag('scarlet_lady');
					player.removeTag('chronobug');
					player.addTag('shadybug');
				}
				if(r.selection == 5) {
					player.removeTag('is_lucky_charm');
					player.removeTag('ladybug');
					player.removeTag('mister_bug');
					player.removeTag('scarabella');
					player.removeTag('scarlet_lady');
					player.removeTag('shadybug');
					player.addTag('chronobug');
				}
			}
		)
	}
	function ladybugMiraculousFusionPreference() {
		const form = new ActionFormData();
			form.title('title.choose_suit');
			form.button('Ladyfly');
			form.button('Monarch Bug');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('monarch_bug');
					player.addTag('ladyfly');
				}
				if(r.selection == 1) {
					player.removeTag('ladyfly');
					player.addTag('monarch_bug');
				}
			}
		)
	}
});