import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (itemType === 'miraculous:peacock_fan') {
			event.source.runCommandAsync('give @s[tag=!use_amok] miraculous:fan_feather');
			event.source.runCommandAsync('tag @s[tag=!use_amok] add use_amok');
		}
	}
);
world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (itemType === 'miraculous:fan_feather') {
			event.source.runCommandAsync('playsound amok @a ~~~');
			event.source.runCommandAsync('replaceitem entity @s slot.weapon.mainhand 0 miraculous:amok 1 0 {\"keep_on_death\":{}}');
			event.source.runCommandAsync('tag @s[tag=use_amok, tag=!full_power] add peacock_miraculous_timer_on');
		}
	}
);
world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:amok') system.run(() => peacockMiraculousPowerMenu(player));

	function peacockMiraculousPowerMenu() {
		const form = new ActionFormData();
			form.title('title.choose_sentibeings');
			form.button('button.sentilollipop', 'textures/icons/sentilollipop');
			form.button('button.sentiwolf', 'textures/icons/sentiwolf');
			form.button('button.senticow', 'textures/icons/senticow');
			form.button('button.sentichicken', 'textures/icons/sentichicken');
			form.button('button.sentibug', 'textures/icons/sentibug');
			form.button('button.sentibubbler', 'textures/icons/sentibubbler');
			form.show(player).then(r => {
				if (r.canceled) {
					return;
				}
				if (r.selection !== null) {
					player.runCommandAsync("clear @s miraculous:amok 0 1");
					player.runCommandAsync("event entity @s miraculous:summon_sentibeings");
					player.runCommandAsync("tellraw @a {\"rawtext\":[{\"text\":\"§1<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:fly_away_amok\"}]}");
				}
				if(r.selection == 0) {
					player.addTag('sentilollipop');
					system.runTimeout(() => {
					player.removeTag('sentilollipop');
					}, 5);
				}
				if(r.selection == 1) {
					player.addTag('sentiwolf');
					system.runTimeout(() => {
					player.removeTag('sentiwolf');
					}, 5);
				}
				if(r.selection == 2) {
					player.addTag('senticow');
					system.runTimeout(() => {
					player.removeTag('senticow');
					}, 5);
				}
				if(r.selection == 3) {
					player.addTag('sentichicken');
					system.runTimeout(() => {
					player.removeTag('sentichicken');
					}, 5);
				}
				if(r.selection == 4) {
					player.addTag('sentibug');
					system.runTimeout(() => {
					player.removeTag('sentibug');
					}, 5);
				}
				if(r.selection == 5) {
					player.addTag('sentibubbler');
					system.runTimeout(() => {
					player.removeTag('sentibubbler');
					}, 5);
				}
			}
		)
	}
});