import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:peacock_miraculous' && player.isSneaking == true ) system.run(() => peacockMiraculousPreferenceMenu(player));

	function peacockMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.miraculous.preference');
			form.button('button.suit.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					peacockMiraculousPreference(player);
				}
				if(r.selection == 1) {
					peacockMiraculousSuitPreference(player);
				}
			}
		)
	}
	function peacockMiraculousPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Nathalie', 'textures/items/miraculous/peacock_miraculous/camouflages/camo_peacock_miraculous');
			form.button('Felix', 'textures/items/miraculous/peacock_miraculous/camouflages/felix_camo_peacock_miraculous');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag("felix_peacock");
					player.addTag("nathalie_peacock");
				}
				if(r.selection == 1) {
					player.removeTag("nathalie_peacock");
					player.addTag("felix_peacock");
				}
			}
		)
	}
	function peacockMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Mayura');
			form.button('Argos');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('argos');
					player.addTag('mayura');
				}
				if(r.selection == 1) {
					player.removeTag('mayura');
					player.addTag('argos');
				}
			}
		)
	}
});