import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:turtle_miraculous' && player.isSneaking == true ) system.run(() => turtleMiraculousPreferenceMenu(player));

	function turtleMiraculousPreferenceMenu() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('button.miraculous.preference');
			form.button('button.suit.preference');
			form.show(player).then(r => {
				if(r.selection == 0) {
					turtleMiraculousPreference(player);
				}
				if(r.selection == 1) {
					turtleMiraculousSuitPreference(player);
				}
			}
		)
	}
	function turtleMiraculousPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Nino', 'textures/items/miraculous/turtle_miraculous/camouflages/camo_turtle_miraculous');
			form.button('Marinette', 'textures/items/miraculous/turtle_miraculous/camouflages/marinette_camo_turtle_miraculous');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag("marinette_turtle");
					player.addTag("nino_turtle");
				}
				if(r.selection == 1) {
					player.removeTag("nino_turtle");
					player.addTag("marinette_turtle");
				}
			}
		)
	}
	function turtleMiraculousSuitPreference() {
		const form = new ActionFormData();
			form.title('title.preference');
			form.button('Carapace');
			form.button('Jade Turtle');
			form.button('Koki Marina');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.removeTag('jade_turtle');
					player.removeTag('koki_marina');
					player.addTag('carapace');
				}
				if(r.selection == 1) {
					player.removeTag('koki_marina');
					player.removeTag('carapace');
					player.addTag('jade_turtle');
				}
				if(r.selection == 2) {
					player.removeTag('jade_turtle');
					player.removeTag('carapace');
					player.addTag('koki_marina');
				}
			}
		)
	}
});