import { world, system } from "@minecraft/server";
import { ActionFormData, MessageFormData, ModalFormData } from "@minecraft/server-ui";

world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
		if (event.source.isSneaking) {
			if (itemType === 'miraculous:turtle_shield') {
				event.source.runCommandAsync('fill ~-7~9~-7~7~-1~7 air replace miraculous:shell_ter_block');
				event.source.runCommandAsync('tag @s[tag=full_power] remove use_shell_ter');
			}
		}
	}
);
world.beforeEvents.itemUse.subscribe(event => {
	const itemType = event.itemStack.typeId;
	const player = event.source;
		if (itemType === 'miraculous:turtle_shield' && !player.hasTag('use_shell_ter') && player.isSneaking == false) system.run(() => turtleMiraculousPowerMenu(player));

	function turtleMiraculousPowerMenu() {
		const form = new ActionFormData();
			form.title('title.shell_ter_menu');
			form.button('3x3');
			form.button('5x5');
			form.button('7x7');
			form.show(player).then(r => {
				if(r.selection == 0) {
					player.runCommandAsync('tellraw @a[tag=!use_shell_ter] {\"rawtext\":[{\"text\":\"§2<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:shell_ter\"}]}');
					player.runCommandAsync('execute as @s[tag=!use_shell_ter] run playsound shell_ter @a ~~~');
					player.runCommandAsync('fill ~-7~9~-7~7~-1~7 air replace miraculous:shell_ter_block');
					player.runCommandAsync('tag @s[tag=shell_ter_off] remove use_shell_ter');
					player.runCommandAsync('execute as @s[tag=!use_shell_ter] run function shell_ter_on');
					player.runCommandAsync('tag @s[tag=shell_ter_off] remove shell_ter_off');
					player.runCommandAsync('tag @s[tag=!shell_ter_off, tag=use_shell_ter] add shell_ter_off');
					player.runCommandAsync('tag @s[tag=!use_shell_ter] add use_shell_ter');
					player.runCommandAsync('tag @s[tag=use_shell_ter, tag=!full_power] add turtle_miraculous_timer_on');
				}
				if(r.selection == 1) {
					player.runCommandAsync('tellraw @a[tag=!use_shell_ter] {\"rawtext\":[{\"text\":\"§2<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:shell_ter\"}]}');
					player.runCommandAsync('execute as @s[tag=!use_shell_ter] run playsound shell_ter @a ~~~');
					player.runCommandAsync('fill ~-7~9~-7~7~-1~7 air replace miraculous:shell_ter_block');
					player.runCommandAsync('tag @s[tag=shell_ter_off] remove use_shell_ter');
					player.runCommandAsync('execute as @s[tag=!use_shell_ter] run function shell_ter_on1');
					player.runCommandAsync('tag @s[tag=shell_ter_off] remove shell_ter_off');
					player.runCommandAsync('tag @s[tag=!shell_ter_off, tag=use_shell_ter] add shell_ter_off');
					player.runCommandAsync('tag @s[tag=!use_shell_ter] add use_shell_ter');
					player.runCommandAsync('tag @s[tag=use_shell_ter, tag=!full_power] add turtle_miraculous_timer_on');
				}
				if(r.selection == 2) {
					player.runCommandAsync('tellraw @a[tag=!use_shell_ter] {\"rawtext\":[{\"text\":\"§2<\"},{\"selector\":\"@s\"},{\"text\":\">§r\"},{\"translate\":\"tile.miraculous:shell_ter\"}]}');
					player.runCommandAsync('execute as @s[tag=!use_shell_ter] run playsound shell_ter @a ~~~');
					player.runCommandAsync('fill ~-7~9~-7~7~-1~7 air replace miraculous:shell_ter_block');
					player.runCommandAsync('tag @s[tag=shell_ter_off] remove use_shell_ter');
					player.runCommandAsync('execute as @s[tag=!use_shell_ter] run function shell_ter_on2');
					player.runCommandAsync('tag @s[tag=shell_ter_off] remove shell_ter_off');
					player.runCommandAsync('tag @s[tag=!shell_ter_off, tag=use_shell_ter] add shell_ter_off');
					player.runCommandAsync('tag @s[tag=!use_shell_ter] add use_shell_ter');
					player.runCommandAsync('tag @s[tag=use_shell_ter, tag=!full_power] add turtle_miraculous_timer_on');
				}
			}
		)
	}
});